require '_h2ph_pre.ph';

unless(defined(&_SYS_PTE_H)) {
    eval 'sub _SYS_PTE_H () {1;}' unless defined(&_SYS_PTE_H);
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
	require 'sys/mmu.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub PTE_GB_MASK () {0x100;}' unless defined(&PTE_GB_MASK);
    eval 'sub PTE_RM_MASK () {0x60;}' unless defined(&PTE_RM_MASK);
    eval 'sub PTE_REF_MASK () {0x20;}' unless defined(&PTE_REF_MASK);
    eval 'sub PTE_MOD_MASK () {0x40;}' unless defined(&PTE_MOD_MASK);
    eval 'sub PTE_RW_MASK () {0x02;}' unless defined(&PTE_RW_MASK);
    eval 'sub PTE_RM_SHIFT () {5;}' unless defined(&PTE_RM_SHIFT);
    eval 'sub PTE_PERMS {
        local($b) = @_;
	    eval q(((($b) & 0x3) << 1));
    }' unless defined(&PTE_PERMS);
    eval 'sub PTE_PERMMASK () {((0x3 << 1));}' unless defined(&PTE_PERMMASK);
    eval 'sub PTE_PERMSHIFT () {(1);}' unless defined(&PTE_PERMSHIFT);
    eval 'sub PTE_WRITETHRU {
        local($w) = @_;
	    eval q(((($w) & 0x1) << 3));
    }' unless defined(&PTE_WRITETHRU);
    eval 'sub PTE_NONCACHEABLE {
        local($d) = @_;
	    eval q(((($d) & 0x1) << 4));
    }' unless defined(&PTE_NONCACHEABLE);
    eval 'sub PTE_REF {
        local($r) = @_;
	    eval q(((($r) & 0x1) << 5));
    }' unless defined(&PTE_REF);
    eval 'sub PTE_MOD {
        local($m) = @_;
	    eval q(((($m) & 0x1) << 6));
    }' unless defined(&PTE_MOD);
    eval 'sub PTE_OSRESERVED {
        local($o) = @_;
	    eval q(((($o) & 0x7) << 9));
    }' unless defined(&PTE_OSRESERVED);
    eval 'sub pte_valid {
        local($pte) = @_;
	    eval q(((($pte))-> &Present));
    }' unless defined(&pte_valid);
    eval 'sub pte_ro {
        local($pte) = @_;
	    eval q((!((($pte))-> &AccessPermissions & 1)));
    }' unless defined(&pte_ro);
    eval 'sub MAKE_PROT {
        local($v) = @_;
	    eval q( &PTE_PERMS($v));
    }' unless defined(&MAKE_PROT);
    eval 'sub PG_PROT () { &MAKE_PROT(0x3);}' unless defined(&PG_PROT);
    eval 'sub PG_KW () { &MAKE_PROT( &MMU_STD_SRWX);}' unless defined(&PG_KW);
    eval 'sub PG_KR () { &MAKE_PROT( &MMU_STD_SRX);}' unless defined(&PG_KR);
    eval 'sub PG_UW () { &MAKE_PROT( &MMU_STD_SRWXURWX);}' unless defined(&PG_UW);
    eval 'sub PG_URKR () { &MAKE_PROT( &MMU_STD_SRXURX);}' unless defined(&PG_URKR);
    eval 'sub PG_UR () { &MAKE_PROT( &MMU_STD_SRXURX);}' unless defined(&PG_UR);
    eval 'sub PG_UPAGE () { &PG_KW;}' unless defined(&PG_UPAGE);
    eval 'sub PG_V () {1;}' unless defined(&PG_V);
    unless(defined(&_ASM)) {
	if(defined(&PTE36)) {
	    eval 'sub UNLOAD_PTE {
	        local($a, $b) = @_;
    		eval q({ ()-> &pte64_0_31 = ; ()-> &pte64_32_64 = ((($b)) >> 32); });
	    }' unless defined(&UNLOAD_PTE);
	    eval 'sub LOAD_PTE {
	        local($a, $b) = @_;
    		eval q({ ()-> &pte64_32_64 = (() >> 32); (($a))-> &pte64_0_31 = ($b); });
	    }' unless defined(&LOAD_PTE);
	    eval 'sub INVALIDATE_PTE {
	        local($a) = @_;
    		eval q((*()) =  &MMU_STD_INVALIDPTE);
	    }' unless defined(&INVALIDATE_PTE);
	    eval 'sub PTE_PFN {
	        local($p) = @_;
    		eval q(((($p)) >> 12));
	    }' unless defined(&PTE_PFN);
	    eval 'sub PTE32_PFN {
	        local($p) = @_;
    		eval q(((($p)) >> 12));
	    }' unless defined(&PTE32_PFN);
	    eval 'sub PTEVAL2PFN {
	        local($p) = @_;
    		eval q((($p) >> 12));
	    }' unless defined(&PTEVAL2PFN);
	    eval 'sub pte_valid {
	        local($pte) = @_;
    		eval q(((($pte))-> &Present));
	    }' unless defined(&pte_valid);
	    eval 'sub pte32_valid {
	        local($pte) = @_;
    		eval q(((($pte))-> &Present));
	    }' unless defined(&pte32_valid);
	    eval 'sub MMU_PTTBL_SIZE () {32;}' unless defined(&MMU_PTTBL_SIZE);
	    eval 'sub MMU_L1_INDEX {
	        local($a) = @_;
    		eval q(((($a)) >> 21));
	    }' unless defined(&MMU_L1_INDEX);
	    eval 'sub MMU_L1_KINDEX {
	        local($a) = @_;
    		eval q((((($a) - 0xc0000000)) >> 21));
	    }' unless defined(&MMU_L1_KINDEX);
	    eval 'sub MMU_L2_INDEX {
	        local($a) = @_;
    		eval q((((($a)) >> 12) & 0x1ff));
	    }' unless defined(&MMU_L2_INDEX);
	    eval 'sub MMU32_L1_VA {
	        local($a) = @_;
    		eval q(((($a)) << 22));
	    }' unless defined(&MMU32_L1_VA);
	    eval 'sub MMU32_L1_INDEX {
	        local($a) = @_;
    		eval q(((($a)) >> 22));
	    }' unless defined(&MMU32_L1_INDEX);
	    eval 'sub MMU32_L2_INDEX {
	        local($a) = @_;
    		eval q((((($a)) >> 12) & 0x3ff));
	    }' unless defined(&MMU32_L2_INDEX);
	    eval 'sub PAGETABLE_INDEX {
	        local($a) = @_;
    		eval q( &MMU_L2_INDEX($a));
	    }' unless defined(&PAGETABLE_INDEX);
	    eval 'sub PAGEDIR_INDEX {
	        local($a) = @_;
    		eval q( &MMU_L1_INDEX($a));
	    }' unless defined(&PAGEDIR_INDEX);
	    eval 'sub PAGETABLE32_INDEX {
	        local($a) = @_;
    		eval q( &MMU32_L2_INDEX($a));
	    }' unless defined(&PAGETABLE32_INDEX);
	    eval 'sub PAGEDIR32_INDEX {
	        local($a) = @_;
    		eval q( &MMU32_L1_INDEX($a));
	    }' unless defined(&PAGEDIR32_INDEX);
	    eval 'sub two_mb_page {
	        local($pte) = @_;
    		eval q((*(($pte)) & 0x80));
	    }' unless defined(&two_mb_page);
	    eval 'sub four_mb_page {
	        local($pte) = @_;
    		eval q((*(($pte)) & 0x80));
	    }' unless defined(&four_mb_page);
	    eval 'sub IN_SAME_2MB_PAGE {
	        local($a, $b) = @_;
    		eval q(( &MMU_L1_INDEX($a) ==  &MMU_L1_INDEX($b)));
	    }' unless defined(&IN_SAME_2MB_PAGE);
	    eval 'sub TWOMB_PDE {
	        local($a, $g,  $b, $c) = @_;
    		eval q(((((($a))) <<  &MMU_STD_PAGESHIFT) | (($g) << 8) | 0x80 |((($b) & 0x03) << 1) | ($c)));
	    }' unless defined(&TWOMB_PDE);
	    eval 'sub TWOMB_PDE_ATTR {
	        local($a, $g,  $b, $pati, $ce, $wt, $c) = @_;
    		eval q(((((($a))) <<  &MMU_STD_PAGESHIFT) | (($g) << 8) | 0x80 |((($b) & 0x03) << 1) | (($pati) << 12)| ((!($ce)) << 4) | (($wt) << 3) | ($c)));
	    }' unless defined(&TWOMB_PDE_ATTR);
	    eval 'sub PTE_GRDA () {0x1e0;}' unless defined(&PTE_GRDA);
	    eval 'sub MOVPTE32_2_PTE64 {
	        local($a, $b) = @_;
    		eval q(((*()) = ((*(($a)) & ~ &PTE_GRDA))));
	    }' unless defined(&MOVPTE32_2_PTE64);
	    eval 'sub MOV4MBPTE32_2_2MBPTE64 {
	        local($a, $b) = @_;
    		eval q(((*()) = (((*(($a)) & ~ &PTE_GRDA))| 0x80)));
	    }' unless defined(&MOV4MBPTE32_2_2MBPTE64);
	    eval 'sub MMU_STD_INVALIDPTE () {(0);}' unless defined(&MMU_STD_INVALIDPTE);
	    eval 'sub NPDPERAS () {4;}' unless defined(&NPDPERAS);
	    eval 'sub NPTEPERPT () {512;}' unless defined(&NPTEPERPT);
	    eval 'sub NPTESHIFT () {9;}' unless defined(&NPTESHIFT);
	    eval 'sub PTSIZE () {( &NPTEPERPT *  &MMU_PAGESIZE);}' unless defined(&PTSIZE);
	    eval 'sub PTOFFSET () {( &PTSIZE - 1);}' unless defined(&PTOFFSET);
	    eval 'sub NPTEPERPT32 () {1024;}' unless defined(&NPTEPERPT32);
	    eval 'sub NPTESHIFT32 () {10;}' unless defined(&NPTESHIFT32);
	    eval 'sub PTSIZE32 () {( &NPTEPERPT32 *  &MMU_PAGESIZE);}' unless defined(&PTSIZE32);
	    eval 'sub MMU_NPTE_ONE () {2048;}' unless defined(&MMU_NPTE_ONE);
	    eval 'sub MMU_NPTE_TWO () {512;}' unless defined(&MMU_NPTE_TWO);
	    eval 'sub MMU32_NPTE_ONE () {1024;}' unless defined(&MMU32_NPTE_ONE);
	    eval 'sub MMU32_NPTE_TWO () {1024;}' unless defined(&MMU32_NPTE_TWO);
	    eval 'sub TWOMB_PAGESIZE () {0x200000;}' unless defined(&TWOMB_PAGESIZE);
	    eval 'sub TWOMB_PAGEOFFSET () {( &TWOMB_PAGESIZE - 1);}' unless defined(&TWOMB_PAGEOFFSET);
	    eval 'sub TWOMB_PAGESHIFT () {21;}' unless defined(&TWOMB_PAGESHIFT);
	    eval 'sub LARGE_PAGESHIFT () {21;}' unless defined(&LARGE_PAGESHIFT);
	    eval 'sub ONEGB () {0x40000000;}' unless defined(&ONEGB);
	    eval 'sub PAGEDIRPTR_MAPSZ () { &ONEGB;}' unless defined(&PAGEDIRPTR_MAPSZ);
	    eval 'sub KPGDIR_PGCNT () {( &howmany((0-  &kernelbase),  &PAGEDIRPTR_MAPSZ));}' unless defined(&KPGDIR_PGCNT);
	    eval 'sub mmu_pgdirptbl_load {
	        local($cpu, $index, $value) = @_;
    		eval q((-> $cpu_pgdirpttbl[] = ($value)));
	    }' unless defined(&mmu_pgdirptbl_load);
	    eval 'sub CAS_PTE {
	        local($a, $b, $c) = @_;
    		eval q( &cas64($a, $b, $c));
	    }' unless defined(&CAS_PTE);
	    eval 'sub BOOT_SIZE () {(2*  &FOURMB_PAGESIZE);}' unless defined(&BOOT_SIZE);
	    eval 'sub PAGEDIR_SIZE () {( &MMU_PAGESIZE *  &NPDPERAS);}' unless defined(&PAGEDIR_SIZE);
	    eval 'sub LGPG_PDE () { &TWOMB_PDE_ATTR;}' unless defined(&LGPG_PDE);
	    eval 'sub LARGE_PAGE () { &two_mb_page;}' unless defined(&LARGE_PAGE);
	    eval 'sub ALIGN_TONEXT_LGPAGE {
	        local($a) = @_;
    		eval q(((($a) +  &TWOMB_PAGESIZE) & ~ &TWOMB_PAGEOFFSET););
	    }' unless defined(&ALIGN_TONEXT_LGPAGE);
	    eval 'sub LARGEPAGESIZE () { &TWOMB_PAGESIZE;}' unless defined(&LARGEPAGESIZE);
	} else {
	    eval 'sub pte32_t () { &pte_t;}' unless defined(&pte32_t);
	    eval 'sub LOAD_PTE {
	        local($a, $b) = @_;
    		eval q((*($a) = $b));
	    }' unless defined(&LOAD_PTE);
	    eval 'sub UNLOAD_PTE {
	        local($a, $b) = @_;
    		eval q((*($a) = $b));
	    }' unless defined(&UNLOAD_PTE);
	    eval 'sub INVALIDATE_PTE {
	        local($a) = @_;
    		eval q(*($a) =  &MMU_STD_INVALIDPTE);
	    }' unless defined(&INVALIDATE_PTE);
	    eval 'sub FOURMB_PDE_ATTR {
	        local($a, $g,  $b, $pati, $ce, $wt, $c) = @_;
    		eval q(((((($a))) <<  &MMU_STD_PAGESHIFT) | (($g) << 8) | 0x80 |((($b) & 0x03) << 1) | (($pati) << 12)| ((!($ce)) << 4) | (($wt) << 3) | ($c)));
	    }' unless defined(&FOURMB_PDE_ATTR);
	    eval 'sub PTE_VALID () {0x01;}' unless defined(&PTE_VALID);
	    eval 'sub PTE_LARGEPAGE () {0x80;}' unless defined(&PTE_LARGEPAGE);
	    eval 'sub PTE_SRWX () {0x02;}' unless defined(&PTE_SRWX);
	    eval 'sub NPTEPERPT () {1024;}' unless defined(&NPTEPERPT);
	    eval 'sub NPTESHIFT () {10;}' unless defined(&NPTESHIFT);
	    eval 'sub PTSIZE () {( &NPTEPERPT *  &MMU_PAGESIZE);}' unless defined(&PTSIZE);
	    eval 'sub MMU_NPTE_ONE () {1024;}' unless defined(&MMU_NPTE_ONE);
	    eval 'sub MMU_NPTE_TWO () {1024;}' unless defined(&MMU_NPTE_TWO);
	    eval 'sub MMU_L1_VA {
	        local($a) = @_;
    		eval q(((($a)) << 22));
	    }' unless defined(&MMU_L1_VA);
	    eval 'sub MMU_L1_INDEX {
	        local($a) = @_;
    		eval q(((($a)) >> 22));
	    }' unless defined(&MMU_L1_INDEX);
	    eval 'sub MMU_L2_INDEX {
	        local($a) = @_;
    		eval q((((($a)) >> 12) & 0x3ff));
	    }' unless defined(&MMU_L2_INDEX);
	    eval 'sub PAGETABLE_INDEX {
	        local($a) = @_;
    		eval q( &MMU_L2_INDEX($a));
	    }' unless defined(&PAGETABLE_INDEX);
	    eval 'sub PAGEDIR_INDEX {
	        local($a) = @_;
    		eval q( &MMU_L1_INDEX($a));
	    }' unless defined(&PAGEDIR_INDEX);
	    eval 'sub PTE_PFN {
	        local($p) = @_;
    		eval q(((($p)) >> 12));
	    }' unless defined(&PTE_PFN);
	    eval 'sub PTEVAL2PFN {
	        local($p) = @_;
    		eval q((($p) >> 12));
	    }' unless defined(&PTEVAL2PFN);
	    eval 'sub MMU_L2_VA {
	        local($a) = @_;
    		eval q((($a) << 12));
	    }' unless defined(&MMU_L2_VA);
	    eval 'sub four_mb_page {
	        local($pte) = @_;
    		eval q((*(($pte)) & 0x80));
	    }' unless defined(&four_mb_page);
	    eval 'sub MMU_STD_INVALIDPTE () {(0);}' unless defined(&MMU_STD_INVALIDPTE);
	    eval 'sub PTOFFSET () {( &PTSIZE - 1);}' unless defined(&PTOFFSET);
	    eval 'sub NPDPERAS () {1;}' unless defined(&NPDPERAS);
	    eval 'sub MMU32_L1_INDEX () { &MMU_L1_INDEX;}' unless defined(&MMU32_L1_INDEX);
	    eval 'sub MMU32_L2_INDEX () { &MMU_L2_INDEX;}' unless defined(&MMU32_L2_INDEX);
	    eval 'sub pte32_valid () { &pte_valid;}' unless defined(&pte32_valid);
	    eval 'sub LARGE_PAGESHIFT () {22;}' unless defined(&LARGE_PAGESHIFT);
	    eval 'sub CAS_PTE {
	        local($a, $b, $c) = @_;
    		eval q( &cas32($a, $b, $c));
	    }' unless defined(&CAS_PTE);
	    eval 'sub BOOT_SIZE () {(0);}' unless defined(&BOOT_SIZE);
	    eval 'sub PAGEDIR_SIZE () {( &MMU_PAGESIZE);}' unless defined(&PAGEDIR_SIZE);
	    eval 'sub LGPG_PDE () { &FOURMB_PDE_ATTR;}' unless defined(&LGPG_PDE);
	    eval 'sub LARGE_PAGE () { &four_mb_page;}' unless defined(&LARGE_PAGE);
	    eval 'sub LARGEPAGESIZE () { &FOURMB_PAGESIZE;}' unless defined(&LARGEPAGESIZE);
	    eval 'sub PAGEDIRPTR_MAPSZ () {0;}' unless defined(&PAGEDIRPTR_MAPSZ);
	    eval 'sub ALIGN_TONEXT_LGPAGE {
	        local($a) = @_;
    		eval q(((($a) +  &FOURMB_PAGESIZE) & ~ &FOURMB_PAGEOFFSET););
	    }' unless defined(&ALIGN_TONEXT_LGPAGE);
	}
	eval 'sub MRPTEOF {
	    local($ppn, $os, $m, $r, $c, $w, $a, $p) = @_;
    	    eval q(((((($ppn)))<<12)| (($os)<<9)|(($m)<<6)|(($r)<<5)| ((!($c))<<4)|(($w)<<3)|(($a)<<1)|$p));
	}' unless defined(&MRPTEOF);
	eval 'sub MRDPTEOF {
	    local($ppn, $os, $m, $r, $pat_i, $c, $w, $a, $p) = @_;
    	    eval q(((((($ppn)))<<12)| (($os)<<9)|(($pat_i)<<7)|(($m)<<6)|(($r)<<5)| ((!($c))<<4)|(($w)<<3)|(($a)<<1)|$p));
	}' unless defined(&MRDPTEOF);
	eval 'sub PTEOF {
	    local($p, $a, $c) = @_;
    	    eval q( &MRPTEOF($p, 0, 0, 0, $c, 0, $a, 1));
	}' unless defined(&PTEOF);
	eval 'sub PTBL_ENT {
	    local($p) = @_;
    	    eval q((((($p))<<12)|0x01));
	}' unless defined(&PTBL_ENT);
	eval 'sub PTEOF_C {
	    local($p, $a) = @_;
    	    eval q((((($p))<<12)|(($a)<<1)|1));
	}' unless defined(&PTEOF_C);
	eval 'sub PTEOF_CS {
	    local($p, $a, $s) = @_;
    	    eval q((((($p))<<12)|(($a)<<1)|(($s) << 9)|1));
	}' unless defined(&PTEOF_CS);
	eval 'sub MAKE_PFNUM {
	    local($a) = @_;
    	    eval q((*(($a)) >> 12));
	}' unless defined(&MAKE_PFNUM);
	eval 'sub CHG_PFN {
	    local($pteval, $p) = @_;
    	    eval q(( = ( & 0xfff) | (($p)) << 12));
	}' unless defined(&CHG_PFN);
	eval 'sub pte_konly {
	    local($pte) = @_;
    	    eval q((((*($pte)) & 0x4) == 0));
	}' unless defined(&pte_konly);
	eval 'sub pte_ronly {
	    local($pte) = @_;
    	    eval q((((*($pte)) & 0x2) == 0));
	}' unless defined(&pte_ronly);
	eval 'sub pte_cacheable {
	    local($pte) = @_;
    	    eval q((((*($pte)) & 0x10) == 0));
	}' unless defined(&pte_cacheable);
	eval 'sub pte_writethru {
	    local($pte) = @_;
    	    eval q((((*($pte)) & 0x8) != 0));
	}' unless defined(&pte_writethru);
	eval 'sub pte_pati {
	    local($pte) = @_;
    	    eval q((((*($pte)) & 0x80) != 0));
	}' unless defined(&pte_pati);
	eval 'sub pte_accessed {
	    local($pte) = @_;
    	    eval q(((*($pte)) & 0x20));
	}' unless defined(&pte_accessed);
	eval 'sub pte_dirty {
	    local($pte) = @_;
    	    eval q(((*($pte)) & 0x40));
	}' unless defined(&pte_dirty);
	eval 'sub pte_accdir {
	    local($pte) = @_;
    	    eval q(((*($pte)) & 0x60));
	}' unless defined(&pte_accdir);
	eval 'sub setpte_scanned {
	    local($a) = @_;
    	    eval q((*($a) |= (1<< 11)));
	}' unless defined(&setpte_scanned);
	eval 'sub clrpte_scanned {
	    local($a) = @_;
    	    eval q((*($a) &= ~(1<< 11)));
	}' unless defined(&clrpte_scanned);
	eval 'sub getpte_scanned {
	    local($a) = @_;
    	    eval q((((*($a)) & (1<< 11)) != 0));
	}' unless defined(&getpte_scanned);
	eval 'sub setpte_noconsist {
	    local($a) = @_;
    	    eval q((*($a) |= (1<< 10)));
	}' unless defined(&setpte_noconsist);
	eval 'sub clrpte_noconsist {
	    local($a) = @_;
    	    eval q((*($a) &= ~(1<< 10)));
	}' unless defined(&clrpte_noconsist);
	eval 'sub getpte_noconsist {
	    local($a) = @_;
    	    eval q((((*($a)) & (1<< 10)) != 0));
	}' unless defined(&getpte_noconsist);
	eval 'sub setpte_nosync {
	    local($a) = @_;
    	    eval q((*($a) |= (1<< 9)));
	}' unless defined(&setpte_nosync);
	eval 'sub clrpte_nosync {
	    local($a) = @_;
    	    eval q((*($a) &= ~(1<< 9)));
	}' unless defined(&clrpte_nosync);
	eval 'sub getpte_nosync {
	    local($a) = @_;
    	    eval q((((*($a)) & (1<< 9)) != 0));
	}' unless defined(&getpte_nosync);
	eval 'sub pte_readonly {
	    local($x) = @_;
    	    eval q((!(*(($x)) & 0x02)));
	}' unless defined(&pte_readonly);
	eval 'sub pte_readonly_and_notdirty {
	    local($x) = @_;
    	    eval q((!(*($x) & 0x42)));
	}' unless defined(&pte_readonly_and_notdirty);
	eval 'sub ptevalue_dirty {
	    local($a) = @_;
    	    eval q((($a) & 0x40));
	}' unless defined(&ptevalue_dirty);
	eval 'sub mmu_pdeptr_cpu {
	    local($cpu, $addr) = @_;
    	    eval q((((($cpu)-> $cpu_pagedir[ &MMU_L1_INDEX($addr)]))));
	}' unless defined(&mmu_pdeptr_cpu);
	eval 'sub mmu_pdeload_cpu {
	    local($cpu, $addr, $value) = @_;
    	    eval q((*( &mmu_pdeptr_cpu($cpu, $addr)) = ($value)));
	}' unless defined(&mmu_pdeload_cpu);
	eval 'sub mmu_pdeptr {
	    local($addr) = @_;
    	    eval q( &mmu_pdeptr_cpu( &CPU, $addr));
	}' unless defined(&mmu_pdeptr);
	eval 'sub mmu_pdeload {
	    local($addr, $value) = @_;
    	    eval q( &mmu_pdeload_cpu( &CPU, $addr, $value));
	}' unless defined(&mmu_pdeload);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
